package main

import (
	"log"

	"go.uber.org/zap"
	"gitea.pena/PenaSide/treasurer/internal/app"
	"gitea.pena/PenaSide/treasurer/internal/initialize"
)

func main() {
	logger, err := zap.NewProduction(zap.AddStacktrace(zap.DPanicLevel))
	if err != nil {
		log.Fatalf("failed to init zap logger: %v", err)
	}

	config, err := initialize.Configuration(".env.test")
	if err != nil {
		logger.Fatal("failed to init config: %v", zap.Error(err))
	}

	if err := app.Run(config, logger); err != nil {
		logger.Fatal("failed to run app: %v", zap.Error(err))
	}
}
