package initialize

import (
	"go.uber.org/zap"
	"gitea.pena/PenaSide/treasurer/internal/errors"
	"gitea.pena/PenaSide/treasurer/internal/worker/mock"
)

type WorkersDeps struct {
	Logger   *zap.Logger
	Services Services
}

type Workers struct {
	Mock *mock.Worker
}

func NewWorkers(deps WorkersDeps) (*Workers, errors.Error) {
	mockWorker, err := mock.New(mock.WorkerDeps{
		Logger:      deps.Logger,
		MockService: deps.Services.Mock,
	})
	if err != nil {
		return nil, err
	}

	return &Workers{
		Mock: mockWorker,
	}, nil
}
