// Package swagger provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.12.4 DO NOT EDIT.
package swagger

// Defines values for Event.
const (
	PaymentCanceled          Event = "payment.canceled"
	PaymentSucceeded         Event = "payment.succeeded"
	PaymentWaitingForCapture Event = "payment.waiting_for_capture"
	RefundSucceeded          Event = "refund.succeeded"
)

// Defines values for PaymentStatus.
const (
	Canceled          PaymentStatus = "canceled"
	Pending           PaymentStatus = "pending"
	Succeeded         PaymentStatus = "succeeded"
	WaitingForCapture PaymentStatus = "waiting_for_capture"
)

// Amount defines model for Amount.
type Amount struct {
	// Currency Трехбуквенный код валюты в формате ISO-4217
	Currency string `json:"currency"`

	// Value Сумма в выбранной валюте
	Value string `json:"value"`
}

// Event defines model for Event.
type Event string

// PaymentStatus defines model for PaymentStatus.
type PaymentStatus string

// Recipient defines model for Recipient.
type Recipient struct {
	// AccountId Идентификатор магазина в ЮKassa
	AccountId string `json:"account_id"`

	// GatewayId Идентификатор субаккаунта
	GatewayId string `json:"gateway_id"`
}

// SetPaymentStatusRequest defines model for SetPaymentStatusRequest.
type SetPaymentStatusRequest struct {
	Event  Event         `json:"event"`
	Object YandexPayment `json:"object"`

	// Type Тип объекта. Фиксированное значение — notification (уведомление)
	Type string `json:"type"`
}

// YandexPayment defines model for YandexPayment.
type YandexPayment struct {
	Amount Amount `json:"amount"`

	// CapturedAt Время подтверждения платежа
	CapturedAt *string `json:"captured_at,omitempty"`

	// Confirmation Выбранный способ подтверждения платежа
	Confirmation *map[string]interface{} `json:"confirmation,omitempty"`

	// CreatedAt Время создания заказа
	CreatedAt string `json:"created_at"`

	// Description Описание
	Description *string `json:"description,omitempty"`

	// ExpiresAt Время, до которого вы можете бесплатно отменить или подтвердить платеж
	ExpiresAt *string `json:"expires_at,omitempty"`

	// Id Идентификатор платежа в ЮKassa
	Id           string  `json:"id"`
	IncomeAmount *Amount `json:"income_amount,omitempty"`

	// Paid Признак оплаты заказа
	Paid bool `json:"paid"`

	// PaymentMethod Структура метода платежа (может отличаться от способа платежа)
	PaymentMethod *map[string]interface{} `json:"payment_method,omitempty"`
	Recipient     Recipient               `json:"recipient"`

	// Refundable Возможность провести возврат по API
	Refundable     bool          `json:"refundable"`
	RefundedAmount *Amount       `json:"refunded_amount,omitempty"`
	Status         PaymentStatus `json:"status"`

	// Test Признак тестовой операции
	Test bool `json:"test"`
}

// SetYandexPaymentStatusCanceledJSONRequestBody defines body for SetYandexPaymentStatusCanceled for application/json ContentType.
type SetYandexPaymentStatusCanceledJSONRequestBody = SetPaymentStatusRequest

// SetYandexPaymentStatusSucceededJSONRequestBody defines body for SetYandexPaymentStatusSucceeded for application/json ContentType.
type SetYandexPaymentStatusSucceededJSONRequestBody = SetPaymentStatusRequest

// SetYandexPaymentStatusWaitingJSONRequestBody defines body for SetYandexPaymentStatusWaiting for application/json ContentType.
type SetYandexPaymentStatusWaitingJSONRequestBody = SetPaymentStatusRequest

// SetYandexRefundStatusSucceededJSONRequestBody defines body for SetYandexRefundStatusSucceeded for application/json ContentType.
type SetYandexRefundStatusSucceededJSONRequestBody = SetPaymentStatusRequest
