package models

import (
	"gitea.pena/PenaSide/treasurer/pkg/mongo"
)

type Config struct {
	HTTP     ConfigurationHTTP
	GRPC     ConfigurationGRPC
	Service  ServiceConfiguration
	Database mongo.Configuration
}

type ConfigurationHTTP struct {
	Host  string `env:"HTTP_HOST,default=localhost"`
	Port  string `env:"HTTP_PORT,default=8080"`
	Domen string `env:"HTTP_DOMEN,required"`
}

type ConfigurationGRPC struct {
	Host string `env:"GRPC_HOST,default=0.0.0.0"`
	Port string `env:"GRPC_PORT,default=8081"`
}

type ServiceConfiguration struct {
	YoomomeyConfiguration YoomomeyConfiguration
	MockConfiguration     MockConfiguration
}

type MockConfiguration struct {
	IsMock      bool   `env:"IS_MOCK,default=false"`
	Host        string `env:"MOCK_SERVICE_HOST,default=http://localhost:8080"`
	YoomomeyURL YoomomeyURL
}

type YoomomeyConfiguration struct {
	StoreID   string `env:"YOOMONEY_STORE_ID,required"`
	SecretKey string `env:"YOOMONEY_SECRET_KEY,required"`
	URL       YoomomeyURL
}

type YoomomeyURL struct {
	Webhooks string `env:"YOOMONEY_WEBHOOKS_URL,required"`
	Payments string `env:"YOOMONEY_PAYMENTS_URL,required"`
}
