package yandex

type PaymentType string

const (
	PaymentTypeBankCard     PaymentType = "bank_card"
	PaymentTypeTinkoff      PaymentType = "tinkoff_bank"
	PaymentTypeSberPay      PaymentType = "sberbank"
	PaymentTypeYoomoney     PaymentType = "yoo_money"
	PaymentTypeMobile       PaymentType = "mobile_balance"
	PaymentTypeSBP          PaymentType = "sbp"
	PaymentTypeSberB2B      PaymentType = "b2b_sberbank"
)

type PaymentMethodBankCard struct {
	Type PaymentType          `json:"type"`
}

type PaymentMethodB2B struct {
	Type           PaymentType `json:"type"`
	PaymentPurpose string      `json:"payment_purpose"`
	VatData        any         `json:"vat_data"`
}

type PaymentMethodPhone struct {
	Type  PaymentType `json:"type"`
}

type PaymentMethodType struct {
	Type PaymentType `json:"type"`
}
