package utils_test

import (
	"testing"

	"github.com/stretchr/testify/assert"
	"gitea.pena/PenaSide/treasurer/internal/utils"
)

func TestConvertAmountToStringFloat(t *testing.T) {
	testCases := []struct {
		name     string
		amount   int64
		expected string
	}{
		{
			name:     "Успешная конвертация числа 10020 в 100.20",
			amount:   10020,
			expected: "100.20",
		},
		{
			name:     "Успешная конвертация числа 10002 в 100.02",
			amount:   10002,
			expected: "100.02",
		},
		{
			name:     "Успешная конвертация числа 12054 в 120.54",
			amount:   12054,
			expected: "120.54",
		},
		{
			name:     "Успешная конвертация числа 198531 в 1985.31",
			amount:   198531,
			expected: "1985.31",
		},
	}

	for _, testCase := range testCases {
		t.Run(testCase.name, func(t *testing.T) {
			assert.Equal(t, testCase.expected, utils.ConvertAmountToStringFloat(testCase.amount))
		})
	}
}
