package utils_test

import (
	"testing"

	"github.com/stretchr/testify/assert"
	"gitea.pena/PenaSide/treasurer/internal/utils"
)

func TestConvertYoomoneySercetsToAuth(t *testing.T) {
	t.Run("Успешная конвертация секретов в base64 используя метод Basic", func(t *testing.T) {
		assert.Equal(t, "Basic aWQ6c2VjcmV0", utils.ConvertYoomoneySercetsToAuth("Basic", "id", "secret"))
	})

	t.Run("Успешная конвертация секретов в base64 используя метод Bearer", func(t *testing.T) {
		assert.Equal(t, "Bearer aWQ6c2VjcmV0", utils.ConvertYoomoneySercetsToAuth("Bearer", "id", "secret"))
	})

	t.Run("Успешная конвертация секретов в base64 используя метод Basic, в котором лишние пробелы", func(t *testing.T) {
		assert.Equal(t, "Basic aWQ6c2VjcmV0", utils.ConvertYoomoneySercetsToAuth("Basic    ", "id", "secret"))
	})
}
