package integration_test

import (
	"context"
	"testing"

	"github.com/stretchr/testify/assert"
	"google.golang.org/grpc"
	"google.golang.org/grpc/credentials/insecure"
	"gitea.pena/PenaSide/treasurer/internal/proto/treasurer"
)

func TestCreatePaymentSberbankB2B(t *testing.T) {
	t.Run("Ошибка при создании платежа через sberbank 2b2 (метод отсутствует)", func(t *testing.T) {
		ctx, cancel := context.WithCancel(context.Background())
		defer cancel()

		clientConnection, grpcErr := grpc.Dial("localhost:8081", grpc.WithTransportCredentials(insecure.NewCredentials()))
		if isNoError := assert.NoError(t, grpcErr); !isNoError {
			return
		}

		treasurerClient := treasurer.NewTreasurerServiceClient(clientConnection)

		_, requestErr := treasurerClient.GetPaymentLinkSberbankB2B(ctx, &treasurer.GetB2BPaymentLinkRequest{})

		assert.Error(t, requestErr)
	})
}
